System.Gadget.settingsUI = "settings.htm"
System.Gadget.onSettingsClosed = updateConfigs;
System.Gadget.onDock = Dock;
System.Gadget.onUndock = Undock;
var numProjects = 10
var start_dir, bin_dir, game_dir, sdk_app;
var sdk_dir = System.Environment.getEnvironmentVariable("sourcesdk");
var ncf_dir = sdk_dir + "\\..\\..\\common\\";

function setEnv() {
	select = document.getElementById("proj-select")
	launch_sdk = document.getElementById("launch_sdk")
	values = select.value.split("|")
	switch(values[0]) {
	case ("ep1"):
	case ("source2007"):
	case ("source2009"):
	case ("orangebox"):
		start_dir = sdk_dir + "\\bin\\" + values[0] + "\\"
		bin_dir = start_dir + "bin\\";
		sdk_app = 211;
		break;
	case ("hl2" ):
		start_dir = bin_dir = ncf_dir + "Half-Life 2\\bin\\";
		sdk_app = 0;
		break;
	case ("hl2dm"):
		start_dir = bin_dir = ncf_dir + "Half-Life 2 Deathmatch\\bin\\";
		sdk_app = 0;
		break
	case ("l4d" ):
		start_dir = bin_dir = ncf_dir + "left 4 dead\\bin\\";
		sdk_app = 513;
		break;
	case ("l4d2"):
		start_dir = bin_dir = ncf_dir + "left 4 dead 2\\bin\\";
		sdk_app = 563;
		break
	case ("swarm"):
		start_dir = bin_dir = ncf_dir + "alien swarm\\bin\\";
		sdk_app = 640;
		break
	case ("portal"):
		start_dir = bin_dir = ncf_dir + "portal\\bin\\";
		sdk_app = 0;
		break
	case ("portal2"):
		start_dir = bin_dir = ncf_dir + "portal 2\\bin\\";
		sdk_app = 629;
		break
	case ("sfm"):
		start_dir = bin_dir = ncf_dir + "SourceFilmmaker\\game\\bin\\";
		sdk_app = 0;
		break
	case ("dod_src"):
		start_dir = bin_dir = ncf_dir + "Day of Defeat Source\\bin\\";
		sdk_app = 0;
		break
	case ("cs_src"):
		start_dir = bin_dir = ncf_dir + "Counter-strike Source\\bin\\";
		sdk_app = 0;
		break
	case ("csgo"):
		start_dir = bin_dir = ncf_dir + "Counter-Strike Global Offensive\\bin\\";
		sdk_app = 745;
		break
	case ("source2013sp"):
		start_dir = bin_dir = ncf_dir + "Source Sdk Base 2013 Singleplayer\\bin\\";
		sdk_app = 0;
		break
	case ("source2013mp"):
		start_dir = bin_dir = ncf_dir + "Source Sdk Base 2013 Multiplayer\\bin\\";
		sdk_app = 0;
		break
	case ("dota2"):
		start_dir = bin_dir = ncf_dir + "dota 2 beta\\bin\\";
		sdk_app = 0;
		break
	case ("tf2"):
		start_dir = bin_dir = ncf_dir + "Team Fortress 2\\bin\\";
		sdk_app = 0;
		break		
	case ("gmod"):
		start_dir = bin_dir = ncf_dir + "GarrysMod\\bin\\";
		sdk_app = 0;
		break
	}
	
	// Now store the VProject environment variable. I use hstart to suppress the CMD window that otherwise appears.
	if ( values[1] != "" ) {
		System.Shell.execute(System.Gadget.path + "\\hstart", "/noconsole \"setx VProject \"" + values[1] + "\"\"");
		game_dir = values[1];
	}
	// Store the selected index for gadget re-inits
	System.Gadget.Settings.writeString("selected_option",select.selectedIndex)
	
	select.blur()
}

function launchSDK() {
	if (sdk_app)
		System.Shell.execute('steam://run/' + sdk_app)
	else
		System.Shell.execute(bin_dir + 'qsdklauncher.exe')
}

function updateConfigs(p_event) {
	if (p_event && p_event.closeAction != p_event.Action.commit) {
		return
	}
	
	var projects_inner = "";
	for(i=0;i<numProjects;i++) {
		var name = System.Gadget.Settings.readString("name" + i);
		var branch = System.Gadget.Settings.readString("branch" + i);
		var path = System.Gadget.Settings.readString("path" + i);
		if ( name != "" && path != "" ) {
			// Queing this up works around an IE bug.
			projects_inner += "<option id=\"" + path + "\" value=\"" + branch + "|" + path + "\">" + name + "</option>"
		}
	}
	// And finally...
	if ( projects_inner != "" ) {
		document.getElementById("proj-select-outer").innerHTML = "<select id=\"proj-select\" onchange=\"setEnv()\">" + projects_inner + "</select>"
		document.getElementById("proj-select").selectedIndex = System.Gadget.Settings.readString("selected_option")
		setEnv()
	}	
}

function Dock() {
		document.body.className = "short"
		document.body.style.height = "119px" // bah!
}
function Undock() {
	document.body.className = ""
	document.body.className, document.body.style.height = ""
}

function runTool(tool) {
	// Steam misbehaves if I launch it then immediately open a tool up.
	// System.Shell.execute( sdk_dir + "\\..\\..\\..\\steam.exe","-silent")
	System.Shell.execute(bin_dir + tool, '-game ' + "\"" + game_dir + "\" -nop4", start_dir)
}
